/*
 RGBlamp 
 Get three byte from udp server to control
 Use TCP UDP RGB APP from play store to control lamp
 https://play.google.com/store/apps/details?id=nextprototypes.tcpudpRGB

 created 31 may 2015
 by Mirco Segatello

 This code is in the public domain.

 */

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>

char ssid[] = "SSID";      //  your network SSID 
char pass[] = "PASS";       // your network password

char packetBuffer[255];
unsigned int localPort = 8080;
IPAddress serverIP(0, 0, 0, 0); // Broadcast communication

WiFiUDP udp; // A UDP instance to send and receive packets over UDP

//uncomment this line if using a Common Anode LED
//#define COMMON_ANODE
//uncomment this line if using Debug message
#define DEBUG

#define PWMRANGE 255  //define PWM range

// Output
int redPin = 12;  // Red LED,   connected to digital pin 12
int grnPin = 13;  // Green LED, connected to digital pin 13
int bluPin = 14;  // Blue LED,  connected to digital pin 14

// Set initial color
int R, G, B;

//on powerUP RED light for search WiFi
//if connect OK and IP assigned OK then Green light for 2 second

void setup()
{
  setColor(255,0,0);
  Serial.println();
  Serial.begin(9600);

  // We start by connecting to a WiFi network
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, pass);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  
  Serial.println();
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  Serial.println("Starting UDP");
  udp.begin(localPort);
  Serial.print("Local port: ");
  Serial.println(udp.localPort());
  setColor(0,255,0);
  delay(2000);
  setColor(0,0,0);
}

void loop()
{
  int packetSize = udp.parsePacket();
  if (packetSize) 
  {
    int len = udp.read(packetBuffer, 255);
    if (len > 0) packetBuffer[len] = 0;

    int R = packetBuffer[0];
    int G = packetBuffer[1];
    int B = packetBuffer[2];
    #ifdef DEBUG
         Serial.println(packetBuffer);
         Serial.print(R);
         Serial.print(" ");
         Serial.print(G);
         Serial.print(" ");
         Serial.println(B); 
    #endif         
    setColor(R,G,B);  
  }
  delay(100);

}



void setColor(int red, int green, int blue)
{
  #ifdef COMMON_ANODE
    red = 255 - red;
    green = 255 - green;
    blue = 255 - blue;
  #endif
  analogWrite(redPin, red);
  analogWrite(grnPin, green);
  analogWrite(bluPin, blue);  
}
